#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.6.0
	Author:         Yannik Niggli

	Script Function:
	Programmverwaltung von instdisk.
	Das Progamm ist zur bersicht bder die Programme
	auf dem Server gedacht.
	Im Hintergrund luft eine MS Access Datenbank.

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Access.au3>
#include <_Loginbox.au3>
#include <Array.au3>

#Region ### START Koda GUI section ### Form=
$Programmverwaltung = GUICreate("Programmverwaltung instdisk", 451, 264, 194, 113)
$g_beschreibung = GUICtrlCreateGroup("Beschreibung", 8, 80, 433, 137)
$e_beschreibung = GUICtrlCreateEdit("", 16, 100, 417, 105, $ES_READONLY)
GUICtrlSetData(-1, "")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$bt_dir = GUICtrlCreateButton("Verzeichnis ffnen", 8, 224, 137, 33, $WS_GROUP)
$bt_update = GUICtrlCreateButton("Update", 300, 224, 137, 33, $WS_GROUP)
$l_title = GUICtrlCreateLabel("Programmverwaltung", 8, 8, 171, 24)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
$Group1 = GUICtrlCreateGroup("Programmauswahl", 8, 32, 433, 49)
$c_type = GUICtrlCreateCombo("Typ", 16, 52, 200, 25)
$c_prog = GUICtrlCreateCombo("Programm", 233, 52, 200, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
;~ 		Case $bt_dir
;~ 			Call ("_OpenDir")
		Case $bt_update
			Call ("_Update")
	EndSwitch
WEnd

;==============================================================================
; Name:				_Update
; Description:		Liest rekursiv alle Ordner im Verzeochnis X:\
;					aus und speichert sie in die MS Access Datenbank
;==============================================================================
Func _Update()
; Hier kommt eine Login Box

;Auflisten der Verzeichnisse
$ret = _GetFilesFolder_Rekursiv('C:\Test\','', 1, 1)
If IsArray($ret) Then
    _ArrayDisplay($ret, 'Rekursiv alle Ordner')
Else
    MsgBox(0, 'Fehler', $ret & @CRLF)
    ConsoleWrite($ret & @CRLF)
EndIf
$aCount = 0
For	$j = 0 to 100 Step 1
_accessAddRecord('C:\Test\prog_db.mdb','Test',$ret[$aCount],'path')
$aCount =$aCount +1
Next
EndFunc   ;==>_Update


;==================================================================================================
; Function Name:   _GetFilesFolder_Rekursiv($sPath [, $sExt='*' [, $iDir=-1 [, $iRetType=0]]])
; Description:     Rekursive Auflistung von Dateien und/oder Ordnern
; Parameter(s):    $sPath     der Basispfad fr die Auflistung ('.' -aktueller Pfad, '..' -Parentpfad)
;                  $sExt      Erweiterung fr Dateiauswahl '*' oder -1 fr alle (Standard)
;                  $iDir      -1 Dateien+Ordner(Standard), 0 nur Dateien, 1 nur Ordner
;      optional:   $iRetType  0 gibt Array, 1 gibt String zurck (Eintrge @LF-getrennt)
; Return Value(s): Array (Standard) od. String mit den gefundenen Pfaden der Dateien und/oder Ordner
;                  Array[0] enthlt die Anzahl der gefundenen Dateien/Ordner
; Author(s):       BugFix (bugfix@autoit.de)
;==================================================================================================
Func _GetFilesFolder_Rekursiv($sPath, $sExt='*', $iDir=-1, $iRetType=0)
    Global $oFSO = ObjCreate('Scripting.FileSystemObject')
    Global $strFiles = ''
    If ($iRetType < 0) Or ($iRetType > 1) Then $iRetType = 0
    If $sExt = -1 Then $sExt = '*'
    If ($iDir < -1) Or ($iDir > 1) Then $iDir = -1
    _ShowSubFolders($oFSO.GetFolder($sPath),$sExt,$iDir)
    If $iRetType = 0 Then
        Local $aOut
        $aOut = StringSplit(StringTrimRight($strFiles,1), @LF)
        If $aOut[1] = '' Then
            ReDim $aOut[1]
            $aOut[0] = 0
        EndIf
        Return $aOut
    Else
        Return StringTrimRight($strFiles,1)
    EndIf
EndFunc

Func _ShowSubFolders($Folder, $Ext='*', $Dir=-1)
    If ($Dir = -1) Or ($Dir = 0) Then
        For $file In $Folder.files
            If $Ext <> '*' Then
                If StringRight($file.Name, StringLen($Ext)) = $Ext Then _
                    $strFiles &= $file.Path & @LF
            Else
                $strFiles &= $file.Path & @LF
            EndIf
        Next
    EndIf
    For $Subfolder In $Folder.SubFolders
        If ($Dir = -1) Or ($Dir = 1) Then $strFiles &= $Subfolder.Path & '\' & @LF
        _ShowSubFolders($Subfolder, $Ext, $Dir)
    Next
EndFunc
